
/*
 * Copyright (C) 2010-2016 Oracle Corporation
 *
 * This file is part of the VirtualBox SDK, as available from
 * http://www.virtualbox.org.  This library is free software; you can
 * redistribute it and/or modify it under the terms of the GNU Lesser General
 * Public License as published by the Free Software Foundation, in version 2.1
 * as it comes in the "COPYING.LIB" file of the VirtualBox SDK distribution.
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * ICloudClient.java
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl (VirtualBox's interface definitions in XML)
 * Generator: src/VBox/Main/glue/glue-java.xsl
 */

package org.virtualbox_6_0;

import org.virtualbox_6_0.jaxws.*;
import javax.xml.ws.*;
import java.util.List;

public class ICloudClient extends IUnknown
{

    public ICloudClient(String wrapped, ObjectRefManager objMgr, VboxPortType port)
    {
        super(wrapped, objMgr, port);
    }
    public static ICloudClient queryInterface(IUnknown obj)
    {
        return obj == null ?  null : new ICloudClient(obj.getWrapped(), obj.getObjMgr(), obj.getRemoteWSPort());
    }

/**
Creates a cloud operation object for the passed profile
if profile name is NULL or empty string creates operation for the active profile.
if profile name is NULL or empty string and there is not the active profile
returns "VERR_INVALID_PARAMETER"
@param cloudCommand The type of the supported cloud commands.

@param condition The successful condition for finishing the command.
The command will be repeated if condition isn't in the needed state

@return UUID of the operation.
It's used later when user chooses and runs this cloud operation

*/
    public String createCommand(org.virtualbox_6_0.CloudCommand cloudCommand, String condition)
    {
        try
        {
            String retVal;
        retVal = port.iCloudClientCreateCommand(obj, org.virtualbox_6_0.jaxws.CloudCommand.fromValue(cloudCommand.name()), condition);
           return retVal;
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Runs a cloud operation by ID
@param Id UUID of the operation.

@param timeout Timeout in seconds.

*/
    public org.virtualbox_6_0.CloudCommandResult runCommand(String Id, Long timeout)
    {
        try
        {
            org.virtualbox_6_0.jaxws.CloudCommandResult retVal;
        retVal = port.iCloudClientRunCommand(obj, Id, timeout);
           return org.virtualbox_6_0.CloudCommandResult.fromValue(retVal.value());
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Runs a set of prepared cloud operations by their ids
@param commandIdList The list of UUID of the operations.

@param parameterNames Initial set of parameter names.

@param parameterValues Initial set of parameter values.

@param progress Progress object to track the operation completion.

*/
    public void runSeveralCommands(List<String> commandIdList, List<String> parameterNames, List<String> parameterValues, org.virtualbox_6_0.IProgress progress)
    {
        try
        {
        port.iCloudClientRunSeveralCommands(obj, commandIdList, parameterNames, parameterValues, ((progress == null) ? null :progress.getWrapped()));
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Validates a cloud operation by ID
@param Id UUID of the operation.

@return if the command is valid return s true else returns false.

*/
    public Boolean validateCommand(String Id)
    {
        try
        {
            Boolean retVal;
        retVal = port.iCloudClientValidateCommand(obj, Id);
           return retVal;
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Check a cloud operation result by ID
@param Id UUID of the operation.

@param startTime Start time of operation.

@param lastTime Time of the last result.

@return The last result of the cloud command.

*/
    public org.virtualbox_6_0.CloudCommandResult checkCommandResult(String Id, Holder<Long> startTime, Holder<Long> lastTime)
    {
        try
        {
        javax.xml.ws.Holder<Long> tmp_startTime = new javax.xml.ws.Holder<Long>();
        javax.xml.ws.Holder<Long> tmp_lastTime = new javax.xml.ws.Holder<Long>();
        javax.xml.ws.Holder<org.virtualbox_6_0.jaxws.CloudCommandResult> retVal = new javax.xml.ws.Holder<org.virtualbox_6_0.jaxws.CloudCommandResult>();
        port.iCloudClientCheckCommandResult(obj, Id, tmp_startTime, tmp_lastTime, retVal);
        startTime.value = tmp_startTime.value;
        lastTime.value = tmp_lastTime.value;
           return org.virtualbox_6_0.CloudCommandResult.fromValue(retVal.value.value());
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Returns the parameters names for this operation.
@param cloudCommand The type of the supported cloud commands.

@return Names of the parameters.

*/
    public List<String> getCommandParameterNames(org.virtualbox_6_0.CloudCommand cloudCommand)
    {
        try
        {
            List<String> retVal;
        retVal = port.iCloudClientGetCommandParameterNames(obj, org.virtualbox_6_0.jaxws.CloudCommand.fromValue(cloudCommand.name()));
           return retVal;
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Returns the value/s for the passed parameter.
@param parameterName Parameter name.

@param parameterType Parameter type.

@param parameterDesc Parameter description.

@return Possible values of the parameter.

*/
    public List<String> getCommandParameterProperties(String parameterName, Holder<String> parameterType, Holder<String> parameterDesc)
    {
        try
        {
        javax.xml.ws.Holder<String> tmp_parameterType = new javax.xml.ws.Holder<String>();
        javax.xml.ws.Holder<String> tmp_parameterDesc = new javax.xml.ws.Holder<String>();
        javax.xml.ws.Holder<List<String>> retVal = new javax.xml.ws.Holder<List<String>>();
        port.iCloudClientGetCommandParameterProperties(obj, parameterName, tmp_parameterType, tmp_parameterDesc, retVal);
        parameterType.value = tmp_parameterType.value;
        parameterDesc.value = tmp_parameterDesc.value;
           return retVal.value;
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Returns the parameters with their values.
@param cloudCommand The type of the supported cloud commands.

@return the parameters with values in json format.

*/
    public String getCommandParameters(org.virtualbox_6_0.CloudCommand cloudCommand)
    {
        try
        {
            String retVal;
        retVal = port.iCloudClientGetCommandParameters(obj, org.virtualbox_6_0.jaxws.CloudCommand.fromValue(cloudCommand.name()));
           return retVal;
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Sets the parameters values for the particular command by ID.
@param Id UUID of the operation.

@param names Names of the parameters.

@param values Values of the parameters.

*/
    public void setCommandParameters(String Id, List<String> names, List<String> values)
    {
        try
        {
        port.iCloudClientSetCommandParameters(obj, Id, names, values);
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Returns the list of commands for particular operation.
@param cloudOperation The type of the supported cloud operation.

@param prep Which list to return: false - general commands, true - preparatory commands

@return The list of cloud commands.

*/
    public List<org.virtualbox_6_0.CloudCommand> getCommandsForOperation(org.virtualbox_6_0.CloudOperation cloudOperation, Boolean prep)
    {
        try
        {
            List<org.virtualbox_6_0.jaxws.CloudCommand> retVal;
        retVal = port.iCloudClientGetCommandsForOperation(obj, org.virtualbox_6_0.jaxws.CloudOperation.fromValue(cloudOperation.name()), prep);
           return Helper.convertEnums(org.virtualbox_6_0.jaxws.CloudCommand.class, org.virtualbox_6_0.CloudCommand.class, retVal);
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Returns the parameters with their values.
@param cloudOperation The type of the supported cloud operation.

@return the parameters with values in json format.

*/
    public String getOperationParameters(org.virtualbox_6_0.CloudOperation cloudOperation)
    {
        try
        {
            String retVal;
        retVal = port.iCloudClientGetOperationParameters(obj, org.virtualbox_6_0.jaxws.CloudOperation.fromValue(cloudOperation.name()));
           return retVal;
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Returns the parameters required to be shown to user for export a VM to a cloud operation.
@return the parameters with values in json format.

*/
    public String getExportParameters()
    {
        try
        {
            String retVal;
        retVal = port.iCloudClientGetExportParameters(obj);
           return retVal;
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Exports a VM described in description parameter
@param description VirtualSystemDescription object which is describing a machine and all required parameters.

@param progress Progress object to track the operation completion.

@param virtualBox Reference to the server-side API root object.

*/
    public void exportVM(org.virtualbox_6_0.IVirtualSystemDescription description, org.virtualbox_6_0.IProgress progress, org.virtualbox_6_0.IVirtualBox virtualBox)
    {
        try
        {
        port.iCloudClientExportVM(obj, ((description == null) ? null :description.getWrapped()), ((progress == null) ? null :progress.getWrapped()), ((virtualBox == null) ? null :virtualBox.getWrapped()));
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }
}
